blob: 7bf7b30b40a4cb93784fcdc5bd67821d05ffd481 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Nicolas Geoffray1c5b6da2016-03-16 10:55:57 +000048export USE_JACK="true"
Alex Lightb55f1ac2016-04-12 15:50:55 -070049export SMALI_ARGS="--experimental"
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
Sebastien Hertz19ac0272015-02-24 17:39:50 +010076# ANDROID_BUILD_TOP is not set in a build environment.
77if [ -z "$ANDROID_BUILD_TOP" ]; then
78 export ANDROID_BUILD_TOP=$oldwd
79fi
80
Andreas Gampef47fb2f2016-06-24 22:30:29 -070081# ANDROID_HOST_OUT is not set in a build environment.
82if [ -z "$ANDROID_HOST_OUT" ]; then
83 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out/}host/linux-x86
84fi
85
Sebastien Hertz19ac0272015-02-24 17:39:50 +010086# If JACK_CLASSPATH is not set, assume it only contains core-libart.
87if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070088 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010089fi
90
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080092
jeffhao5d1ac922011-09-29 17:41:15 -070093info="info.txt"
94build="build"
95run="run"
96expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070097check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070098output="output.txt"
99build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100100cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700101strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700102lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700103testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700104run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000105build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700106
Alex Light91de25f2015-10-28 17:00:06 -0700107quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000108debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700109prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700110target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700111dev_mode="no"
112update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700113debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000114relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800115runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700116usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700117build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700118suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700119trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700120trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700121basic_verify="false"
122gc_verify="false"
123gc_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700124strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700125always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700126never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700127have_dex2oat="yes"
128have_patchoat="yes"
129have_image="yes"
Andreas Gampec23c9c92014-10-28 14:47:25 -0700130pic_image_suffix=""
Jeff Haodcdc85b2015-12-04 14:06:18 -0800131multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000132android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700133bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800134suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700135# By default we will use optimizing.
136image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000137image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700138
139while true; do
140 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700141 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700142 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100143 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700144 shift
Alex Light91de25f2015-10-28 17:00:06 -0700145 elif [ "x$1" = "x--quiet" ]; then
146 quiet="yes"
147 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700148 elif [ "x$1" = "x--use-java-home" ]; then
149 if [ -n "${JAVA_HOME}" ]; then
150 export JAVA="${JAVA_HOME}/bin/java"
151 export JAVAC="${JAVA_HOME}/bin/javac -g"
152 else
153 echo "Passed --use-java-home without JAVA_HOME variable set!"
154 usage="yes"
155 fi
156 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800157 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700158 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800159 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800160 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700161 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700162 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700163 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100164 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100165 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700166 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700167 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800168 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700169 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700170 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700171 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700172 shift
173 elif [ "x$1" = "x--dalvik" ]; then
174 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800175 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700176 shift
Alex Light03a112d2014-08-25 13:25:56 -0700177 elif [ "x$1" = "x--no-dex2oat" ]; then
178 have_dex2oat="no"
179 shift
180 elif [ "x$1" = "x--no-patchoat" ]; then
181 have_patchoat="no"
182 shift
183 elif [ "x$1" = "x--no-image" ]; then
184 have_image="no"
185 shift
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000186 elif [ "x$1" = "x--npic-image" ]; then
187 pic_image_suffix="-npic"
Andreas Gampec23c9c92014-10-28 14:47:25 -0700188 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800189 elif [ "x$1" = "x--multi-image" ]; then
190 multi_image_suffix="-multi"
191 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700192 elif [ "x$1" = "x--pic-test" ]; then
193 run_args="${run_args} --pic-test"
194 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700195 elif [ "x$1" = "x--relocate" ]; then
196 relocate="yes"
197 shift
198 elif [ "x$1" = "x--no-relocate" ]; then
199 relocate="no"
200 shift
201 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100202 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700203 prebuild_mode="yes"
204 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700205 elif [ "x$1" = "x--strip-dex" ]; then
206 run_args="${run_args} --strip-dex"
207 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000208 elif [ "x$1" = "x--debuggable" ]; then
209 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000210 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000211 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700212 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100213 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700214 prebuild_mode="no"
215 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700216 elif [ "x$1" = "x--gcverify" ]; then
217 basic_verify="true"
218 gc_verify="true"
219 shift
220 elif [ "x$1" = "x--gcstress" ]; then
221 basic_verify="true"
222 gc_stress="true"
223 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800224 elif [ "x$1" = "x--suspend-timeout" ]; then
225 shift
226 suspend_timeout="$1"
227 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700228 elif [ "x$1" = "x--image" ]; then
229 shift
230 image="$1"
231 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700232 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000233 elif [ "x$1" = "x-Xcompiler-option" ]; then
234 shift
235 option="$1"
236 run_args="${run_args} -Xcompiler-option $option"
237 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700238 elif [ "x$1" = "x--runtime-option" ]; then
239 shift
240 option="$1"
241 run_args="${run_args} --runtime-option $option"
242 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700243 elif [ "x$1" = "x--gdb-arg" ]; then
244 shift
245 gdb_arg="$1"
246 run_args="${run_args} --gdb-arg $gdb_arg"
247 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700248 elif [ "x$1" = "x--debug" ]; then
249 run_args="${run_args} --debug"
250 shift
251 elif [ "x$1" = "x--gdb" ]; then
252 run_args="${run_args} --gdb"
253 dev_mode="yes"
254 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700255 elif [ "x$1" = "x--strace" ]; then
256 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700257 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700258 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700259 elif [ "x$1" = "x--zygote" ]; then
260 run_args="${run_args} --zygote"
261 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800262 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000263 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700264 image_suffix="-interpreter"
265 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800266 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700267 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000268 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800269 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700270 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700271 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800272 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700273 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700274 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700275 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700276 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700277 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700278 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700279 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700280 elif [ "x$1" = "x--no-optimize" ]; then
281 run_args="${run_args} --no-optimize"
282 shift
283 elif [ "x$1" = "x--no-precise" ]; then
284 run_args="${run_args} --no-precise"
285 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700286 elif [ "x$1" = "x--invoke-with" ]; then
287 shift
288 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700289 if [ "x$what" = "x" ]; then
290 echo "$0 missing argument to --invoke-with" 1>&2
291 usage="yes"
292 break
293 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700294 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700295 shift
296 elif [ "x$1" = "x--dev" ]; then
297 run_args="${run_args} --dev"
298 dev_mode="yes"
299 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700300 elif [ "x$1" = "x--build-only" ]; then
301 build_only="yes"
302 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100303 elif [ "x$1" = "x--build-with-javac-dx" ]; then
304 USE_JACK="false"
305 shift
306 elif [ "x$1" = "x--build-with-jack" ]; then
307 USE_JACK="true"
308 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700309 elif [ "x$1" = "x--output-path" ]; then
310 shift
311 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700312 if [ "x$tmp_dir" = "x" ]; then
313 echo "$0 missing argument to --output-path" 1>&2
314 usage="yes"
315 break
316 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700317 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000318 elif [ "x$1" = "x--android-root" ]; then
319 shift
320 if [ "x$1" = "x" ]; then
321 echo "$0 missing argument to --android-root" 1>&2
322 usage="yes"
323 break
324 fi
325 android_root="$1"
326 run_args="${run_args} --android-root $1"
327 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700328 elif [ "x$1" = "x--update" ]; then
329 update_mode="yes"
330 shift
331 elif [ "x$1" = "x--help" ]; then
332 usage="yes"
333 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700334 elif [ "x$1" = "x--64" ]; then
335 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700336 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700337 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200338 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700339 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200340 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700341 elif [ "x$1" = "x--stream" ]; then
342 trace_stream="true"
343 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700344 elif [ "x$1" = "x--always-clean" ]; then
345 always_clean="yes"
346 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700347 elif [ "x$1" = "x--never-clean" ]; then
348 never_clean="yes"
349 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800350 elif [ "x$1" = "x--dex2oat-swap" ]; then
351 run_args="${run_args} --dex2oat-swap"
352 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700353 elif [ "x$1" = "x--instruction-set-features" ]; then
354 shift
355 run_args="${run_args} --instruction-set-features $1"
356 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700357 elif [ "x$1" = "x--bisection-search" ]; then
358 bisection_search="yes"
359 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000360 elif [ "x$1" = "x--vdex" ]; then
361 run_args="${run_args} --vdex"
362 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000363 elif [ "x$1" = "x--vdex-filter" ]; then
364 shift
365 filter=$1
366 run_args="${run_args} --vdex-filter $filter"
367 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700368 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700369 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700370 usage="yes"
371 break
372 else
373 break
374 fi
375done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700376
Alex Light10bc5a42016-05-10 10:01:22 -0700377run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700378# Allocate file descriptor real_stderr and redirect it to the shell's error
379# output (fd 2).
380if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
381 exec {real_stderr}>&2
382else
383 # In bash before version 4.1 we need to do a manual search for free file
384 # descriptors.
385 FD=3
386 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
387 real_stderr=$FD
388 eval "exec ${real_stderr}>&2"
389fi
390if [ "$quiet" = "yes" ]; then
391 # Force the default standard output and error to go to /dev/null so we will
392 # not print them.
393 exec 1>/dev/null
394 exec 2>/dev/null
395fi
396
397function err_echo() {
398 echo "$@" 1>&${real_stderr}
399}
400
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700401# tmp_dir may be relative, resolve.
402#
403# Cannot use realpath, as it does not exist on Mac.
404# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700405# Cannot use readlink -m, as it does not exist on Mac.
406# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700407noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700408tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700409mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700410
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800411# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000412if [ ! "$runtime" = "jvm" ]; then
413 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
414fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800415
Alex Lighte7873ec2014-08-12 09:53:50 -0700416if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800417 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
418 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700419fi
420if [ "$gc_verify" = "true" ]; then
421 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
422fi
423if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700424 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700425fi
Jeff Hao85139a32014-07-23 11:52:52 -0700426if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700427 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
428 if [ "$trace_stream" = "true" ]; then
429 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
430 # the ability to analyze the file and just write to /dev/null.
431 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
432 # Enable streaming mode.
433 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
434 else
435 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
436 fi
437elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700438 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700439 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700440fi
441
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700442# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100443# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100444function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100445 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800446 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700447 if [ "x${suffix64}" = "x64" ]; then
448 target_arch_name=${grep64bit}
449 else
450 target_arch_name=${grep32bit}
451 fi
452}
453
David Brazdil853a4c32015-09-28 16:15:50 +0100454function guess_host_arch_name() {
455 if [ "x${suffix64}" = "x64" ]; then
456 host_arch_name="x86_64"
457 else
458 host_arch_name="x86"
459 fi
460}
461
Alex Lighta59dd802014-07-02 16:28:08 -0700462if [ "$target_mode" = "no" ]; then
463 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700464 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700465 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700466 exit 1;
467 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700468 fi
469fi
470
Alex Light03a112d2014-08-25 13:25:56 -0700471if [ "$have_patchoat" = "no" ]; then
472 run_args="${run_args} --no-patchoat"
473fi
474
475if [ "$have_dex2oat" = "no" ]; then
476 run_args="${run_args} --no-dex2oat"
477fi
478
Jeff Hao201803f2013-11-20 18:11:39 -0800479if [ ! "$runtime" = "jvm" ]; then
480 run_args="${run_args} --lib $lib"
481fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700482
Jeff Hao201803f2013-11-20 18:11:39 -0800483if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700484 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100485 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800486 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700487 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700488 else
489 true # defaults to using target BOOTCLASSPATH
490 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800491elif [ "$runtime" = "art" ]; then
492 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100493 guess_host_arch_name
Jeff Haodcdc85b2015-12-04 14:06:18 -0800494 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700495 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800496 else
David Brazdil853a4c32015-09-28 16:15:50 +0100497 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800498 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800499 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800500 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700501 if [ "$relocate" = "yes" ]; then
502 run_args="${run_args} --relocate"
503 else
504 run_args="${run_args} --no-relocate"
505 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700506elif [ "$runtime" = "jvm" ]; then
507 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800508 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700509fi
510
Alex Light03a112d2014-08-25 13:25:56 -0700511if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700512 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700513 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700514 exit 1
515 fi
516 if [ "$target_mode" = "no" ]; then
517 framework="${ANDROID_HOST_OUT}/framework"
518 bpath_suffix="-hostdex"
519 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000520 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700521 bpath_suffix=""
522 fi
523 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
524 # fail since these jar files will be stripped.
525 bpath="${framework}/core-libart${bpath_suffix}.jar"
Narayan Kamathd50687e2015-11-17 12:37:27 +0000526 bpath="${bpath}:${framework}/core-oj${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700527 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
528 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700529 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
530 # Pass down the bootclasspath
531 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700532 run_args="${run_args} --no-image"
533fi
534
jeffhao5d1ac922011-09-29 17:41:15 -0700535if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700536 err_echo "--dev and --update are mutually exclusive"
537 usage="yes"
538fi
539
540if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
541 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700542 usage="yes"
543fi
544
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700545if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
546 err_echo "--bisection-search and --prebuild are mutually exclusive"
547 usage="yes"
548fi
549
550if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
551 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
552 usage="yes"
553fi
554
555if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
556 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
557 usage="yes"
558fi
559
jeffhao5d1ac922011-09-29 17:41:15 -0700560if [ "$usage" = "no" ]; then
561 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
562 test_dir=`basename "$oldwd"`
563 else
564 test_dir="$1"
565 fi
566
567 if [ '!' -d "$test_dir" ]; then
568 td2=`echo ${test_dir}-*`
569 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700570 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700571 usage="yes"
572 fi
573 test_dir="$td2"
574 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700575 # Shift to get rid of the test name argument. The rest of the arguments
576 # will get passed to the test run.
577 shift
578fi
579
Søren Gjesse620d0a52016-09-19 11:12:51 +0200580# For building with javac and dx always use Java 7. The dx compiler
581# only support byte codes from Java 7 or earlier (class file major
582# version 51 or lower).
583if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
584 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
585fi
586
jeffhao5d1ac922011-09-29 17:41:15 -0700587if [ "$usage" = "yes" ]; then
588 prog=`basename $prog`
589 (
590 echo "usage:"
591 echo " $prog --help Print this message."
592 echo " $prog [options] [test-name] Run test normally."
593 echo " $prog --dev [options] [test-name] Development mode" \
594 "(dumps to stdout)."
595 echo " $prog --update [options] [test-name] Update mode" \
596 "(replaces expected.txt)."
597 echo ' Omitting the test name or specifying "-" will use the' \
598 "current directory."
599 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000600 echo " -O Run non-debug rather than debug build (off by default)."
601 echo " -Xcompiler-option Pass an option to the compiler."
602 echo " --runtime-option Pass an option to the runtime."
603 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000604 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000605 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700606 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000607 echo " --build-only Build test files only (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200608 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
609 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000610 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800611 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000612 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000613 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700614 echo " --verify-soft-fail Force soft fail verification (off by default)."
615 echo " Verification is enabled if neither --no-verify"
616 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000617 echo " --no-optimize Turn off optimization (on by default)."
618 echo " --no-precise Turn off precise GC (on by default)."
619 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700620 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000621 echo " other runtime options are ignored."
622 echo " --no-dex2oat Run as though dex2oat was failing."
623 echo " --no-patchoat Run as though patchoat was failing."
624 echo " --prebuild Run dex2oat on the files before starting test. (default)"
625 echo " --no-prebuild Do not run dex2oat on the files before starting"
626 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700627 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000628 echo " --relocate Force the use of relocating in the test, making"
629 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000630 echo " address before running."
631 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700632 echo " --image Run the test using a precompiled boot image. (default)"
633 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000634 echo " --host Use the host-mode virtual machine."
635 echo " --invoke-with Pass --invoke-with option to runtime."
636 echo " --dalvik Use Dalvik (off by default)."
637 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700638 echo " --use-java-home Use the JAVA_HOME environment variable"
639 echo " to find the java compiler and runtime"
640 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000641 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700642 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000643 echo " --64 Run the test in 64-bit mode"
644 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700645 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700646 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000647 echo " --gcstress Run with gc stress testing"
648 echo " --gcverify Run with gc verification"
649 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700650 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000651 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000652 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700653 echo " --instruction-set-features [string]"
654 echo " Set instruction-set-features for compilation."
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000655 echo " --npic-image Use an image compiled with non-position independent code "
656 echo " for the boot class path."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800657 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
658 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700659 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700660 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700661 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000662 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800663 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Alex Light91de25f2015-10-28 17:00:06 -0700664 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700665 exit 1
666fi
667
668cd "$test_dir"
669test_dir=`pwd`
670
671td_info="${test_dir}/${info}"
672td_expected="${test_dir}/${expected}"
673
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700674if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700675 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700676 exit 1
677fi
678
679if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700680 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700681 exit 1
682fi
683
684# copy the test to a temp dir and run it
685
Elliott Hughes510c8782011-10-06 10:57:34 -0700686echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700687
688rm -rf "$tmp_dir"
689cp -Rp "$test_dir" "$tmp_dir"
690cd "$tmp_dir"
691
692if [ '!' -r "$build" ]; then
693 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800694else
695 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700696fi
697
698if [ '!' -r "$run" ]; then
699 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800700else
701 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700702fi
703
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700704if [ '!' -r "$check_cmd" ]; then
705 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800706else
707 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700708fi
709
jeffhao5d1ac922011-09-29 17:41:15 -0700710chmod 755 "$build"
711chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700712chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700713
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700714export TEST_NAME=`basename ${test_dir}`
715
Roland Levillain0d5a2812015-11-13 10:07:31 +0000716# arch_supports_read_barrier ARCH
717# -------------------------------
718# Return whether the Optimizing compiler has read barrier support for ARCH.
719function arch_supports_read_barrier() {
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000720 # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the
Roland Levillain0d5a2812015-11-13 10:07:31 +0000721 # moment.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000722 [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ]
Roland Levillain0d5a2812015-11-13 10:07:31 +0000723}
724
David Brazdil4846d132015-01-15 19:07:08 +0000725# Tests named '<number>-checker-*' will also have their CFGs verified with
726# Checker when compiled with Optimizing on host.
727if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000728 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then
Roland Levillain0d5a2812015-11-13 10:07:31 +0000729 # Optimizing has read barrier support for certain architectures
730 # only. On other architectures, compiling is disabled when read
731 # barriers are enabled, meaning that we do not produce a CFG file
732 # as a side-effect of compilation, thus the Checker assertions
733 # cannot be checked. Disable Checker for those cases.
734 #
735 # TODO: Enable Checker when read barrier support is added to more
736 # architectures (b/12687968).
Hiroshi Yamauchifd3161a2017-01-18 14:47:25 -0800737 if [ "x$ART_USE_READ_BARRIER" != xfalse ] \
Roland Levillain0d5a2812015-11-13 10:07:31 +0000738 && (([ "x$host_mode" = "xyes" ] \
739 && ! arch_supports_read_barrier "$host_arch_name") \
740 || ([ "x$target_mode" = "xyes" ] \
741 && ! arch_supports_read_barrier "$target_arch_name")); then
742 run_checker="no"
David Brazdil80fb3942015-07-23 11:53:42 +0100743 # In no-prebuild mode, the compiler is only invoked if both dex2oat and
744 # patchoat are available. Disable Checker otherwise (b/22552692).
Roland Levillain0d5a2812015-11-13 10:07:31 +0000745 elif [ "$prebuild_mode" = "yes" ] \
746 || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100747 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100748
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100749 if [ "$target_mode" = "no" ]; then
750 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100751 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100752 else
753 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100754 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100755 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100756
757 if [ "$debuggable" = "yes" ]; then
758 checker_args="$checker_args --debuggable"
759 fi
760
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100761 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100762 -Xcompiler-option -j1"
763 fi
David Brazdil4846d132015-01-15 19:07:08 +0000764 fi
765fi
766
Mathieu Chartier031768a2015-08-27 10:25:02 -0700767 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700768
Ian Rogers997f0f92014-06-21 22:58:05 -0700769# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100770build_file_size_limit=2048
771run_file_size_limit=2048
Alex Light4694e822016-01-22 10:09:40 -0800772
773# Add tests requiring a higher ulimit to this list. Ulimits might need to be raised to deal with
774# large amounts of expected output or large generated files.
775if echo "$test_dir" | grep -Eq "(083|089|961|964|971)" > /dev/null; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100776 build_file_size_limit=5120
777 run_file_size_limit=5120
Ian Rogers997f0f92014-06-21 22:58:05 -0700778fi
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100779if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then
780 # We will need to `adb pull` the .cfg output from the target onto the host to
781 # run checker on it. This file can be big.
Nicolas Geoffray4151eff2016-11-06 14:24:08 +0000782 build_file_size_limit=32768
783 run_file_size_limit=32768
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100784fi
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100785if [ ${USE_JACK} = "false" ]; then
786 # Set ulimit if we build with dx only, Jack can generate big temp files.
787 if ! ulimit -S "$build_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700788 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100789 fi
Ian Rogers997f0f92014-06-21 22:58:05 -0700790fi
791
jeffhao5d1ac922011-09-29 17:41:15 -0700792good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000793good_build="yes"
794good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700795if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000796 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700797 build_exit="$?"
798 echo "build exit status: $build_exit" 1>&2
799 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100800 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700801 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100802 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800803 echo "${test_dir}: running..." 1>&2
804 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700805 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000806
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800807 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000808 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100809 if [ "$target_mode" = "yes" ]; then
810 adb pull $cfg_output_dir/$cfg_output &> /dev/null
811 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100812 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000813 checker_exit="$?"
814 if [ "$checker_exit" = "0" ]; then
815 good="yes"
816 fi
Alex Light91de25f2015-10-28 17:00:06 -0700817 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000818 else
819 good="yes"
820 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800821 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000822 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700823 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700824elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000825 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700826 build_exit="$?"
827 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100828 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700829 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100830 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800831 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700832 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000833 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100834 if [ "$target_mode" = "yes" ]; then
835 adb pull $cfg_output_dir/$cfg_output &> /dev/null
836 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100837 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000838 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700839 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
840 good="yes"
841 else
Alex Light91de25f2015-10-28 17:00:06 -0700842 cat "$build_output" 1>&${real_stderr} 1>&2
843 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700844 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700845elif [ "$build_only" = "yes" ]; then
846 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000847 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700848 build_exit="$?"
849 if [ "$build_exit" '!=' '0' ]; then
850 cp "$build_output" "$output"
851 echo "build exit status: $build_exit" >>"$output"
852 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
853 if [ "$?" '!=' "0" ]; then
854 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700855 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700856 fi
857 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700858 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700859 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700860 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700861else
David Brazdil4846d132015-01-15 19:07:08 +0000862 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700863 build_exit="$?"
864 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100865 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700866 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100867 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800868 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700869 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000870 run_exit="$?"
871 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700872 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000873 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000874 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100875 if [ "$target_mode" = "yes" ]; then
876 adb pull $cfg_output_dir/$cfg_output &> /dev/null
877 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100878 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000879 checker_exit="$?"
880 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700881 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000882 good_run="no"
883 else
884 good_run="yes"
885 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000886 else
887 good_run="yes"
888 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700889 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000890 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700891 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700892 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
893 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700894 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700895 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700896 max_name_length=$(getconf NAME_MAX ${tmp_dir})
897 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
898 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700899 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700900 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700901 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700902 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000903 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
904 # output == expected
905 good="yes"
906 echo "${test_dir}: succeeded!" 1>&2
907 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700908 fi
909fi
910
jeffhao5d1ac922011-09-29 17:41:15 -0700911(
Alex Lightbfac14a2014-07-30 09:41:21 -0700912 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700913 echo "${test_dir}: FAILED!"
914 echo ' '
915 echo '#################### info'
916 cat "${td_info}" | sed 's/^/# /g'
917 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700918 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700919 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700920 if [ "$strace" = "yes" ]; then
921 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700922 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700923 echo '####################'
924 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700925 echo ' '
926 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700927
Alex Light91de25f2015-10-28 17:00:06 -0700928) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700929
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700930# Attempt bisection only if the test failed.
931if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
932 # Bisecting works by skipping different optimization passes which breaks checker assertions.
933 if [ "$run_checker" == "yes" ]; then
934 echo "${test_dir}: not bisecting, checker test." 1>&2
935 else
936 # Increase file size limit, bisection search can generate large logfiles.
937 if ! ulimit -S unlimited; then
938 err_echo "ulimit file size setting failed"
939 fi
940 echo "${test_dir}: bisecting..." 1>&2
941 cwd=`pwd`
942 maybe_device_mode=""
943 raw_cmd=""
944 if [ "$target_mode" = "yes" ]; then
945 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
946 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
947 # to exec in order to preserve pid when calling dalvikvm. This is required
948 # for bisection search to correctly retrieve logs from device.
949 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
950 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
951 maybe_device_mode="--device"
952 raw_cmd="$DEX_LOCATION/cmdline.sh"
953 else
954 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
955 fi
956 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
957 $maybe_device_mode \
958 --raw-cmd="$raw_cmd" \
959 --check-script="$cwd/check" \
960 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -0700961 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700962 --timeout=300
963 fi
964fi
965
Alex Lightbfac14a2014-07-30 09:41:21 -0700966# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700967if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700968 cd "$oldwd"
969 rm -rf "$tmp_dir"
970 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
971 adb shell rm -rf $DEX_LOCATION
972 fi
973 if [ "$good" = "yes" ]; then
974 exit 0
975 fi
976fi
977
978
979(
980 if [ "$always_clean" = "yes" ]; then
981 echo "${TEST_NAME} files deleted from host "
982 if [ "$target_mode" == "yes" ]; then
983 echo "and from target"
984 fi
985 else
986 echo "${TEST_NAME} files left in ${tmp_dir} on host"
987 if [ "$target_mode" == "yes" ]; then
988 echo "and in ${DEX_LOCATION} on target"
989 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700990 fi
991
Alex Light91de25f2015-10-28 17:00:06 -0700992) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700993
Alex Light6a870fa2016-05-31 16:36:19 -0700994if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
995 exit 0
996else
997 exit 1
998fi